#!/usr/bin/env python

import gtk, gtkmozembed, gobject, threading, time, sys

class PalaApp():

    def __init__(self):

        self.default_padding = 5
        self.timeout = 15000

        # Creo Finestra e WebView 
        self.Window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.Window.set_title("Pala ControllaPagina")
        self.WebView = gtkmozembed.MozEmbed()

        # Creo il VBox per organizzarmi tutto
        VBox = gtk.VBox()
        VBox.pack_end(self.WebView, True, True, self.default_padding)

        label = gtk.Label("Pagina")
        self.UrlField = gtk.Entry()
        self.UrlField.connect('activate',
                              lambda w: self.LoadPage(self.UrlField.get_text()))
        self.CheckPageButton = gtk.Button("Controlla pagina")

        Toolbar = gtk.HBox()
        BackButton = gtk.Button("Indietro", gtk.STOCK_GO_BACK)
        ForwardButton = gtk.Button("Avanti", gtk.STOCK_GO_FORWARD)
        BackButton.connect('clicked', self.ButtonBack_cb)
        ForwardButton.connect('clicked', self.ForwardButton_cb)
        Toolbar.pack_start(BackButton, False, True, self.default_padding)
        Toolbar.pack_start(ForwardButton, False, True, self.default_padding)
        Toolbar.pack_start(label, False, True, 2* self.default_padding)
        Toolbar.pack_start(self.UrlField, True, True, self.default_padding)
        Toolbar.pack_start(self.CheckPageButton, False, False,
                           self.default_padding)
        VBox.pack_end(Toolbar, False, True, self.default_padding)

        self.Window.add(VBox)
        self.Window.resize(740,680)
        self.Window.show_all()

        # Tengo traccia dell'url
        self.WebView.connect('open-uri',
                             lambda w, url: self.UrlField.set_text(url))

        self.Window.connect('destroy', self.Quit)

        # Mi segno l'id della connect del PalaUpdater
        self.updating = False

        self.CheckPageButton.connect('clicked', self.CheckPageButton_cb)

    def GetUrl(self):
        return self.WebView.get_location()

    def ButtonBack_cb(self, w):
        if self.WebView.can_go_back():
            self.WebView.go_back()
    
    def ForwardButton_cb(self, w):
        if self.WebView.can_go_forward():
            self.WebView.go_forward()

    def Quit(self, w):
        gtk.main_quit()

    def LoadPage(self, url):
        """Carica la pagina data nella webView"""
        self.UrlField.set_text(url)
        self.WebView.load_url(url)

    def Reload(self):
        # print "eheh %s" % self.updating
        # self.LoadPage(self.GetUrl())
        print "Faccio il reload"
        self.WebView.reload(gtkmozembed.FLAG_RELOADBYPASSCACHE)
        if self.updating:
            gobject.timeout_add(self.timeout,
                                self.Reload)
        

    def CheckPageButton_cb(self, w):
        if not self.updating:
            self.updating = True
            gobject.timeout_add(self.timeout,
                                self.Reload)
            self.CheckPageButton.set_label("Smetti di controllare la pagina")
        else:
            self.CheckPageButton.set_label("Controlla Pagina")
            self.updating = False

if __name__ == "__main__":

    pala = PalaApp()
    pala.LoadPage("http://www.dm.unipi.it")
   
    gtk.main()
